/*
 * Khoros: $Id$
 */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * $Log$
 */ 

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>                                                       <<<<
   >>>>		Attribute Table  			      <<<<
   >>>>                                                       <<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  */

#include "internals.h"
#include "attributes.h"

AttributeEntry xvf_attribute_table[] = {

{0, XVF_ACTIVATE,	KINT,		xvf_get_activate,
					xvf_set_activate,		},
{0, XVF_SELECTED,	KINT,		xvf_get_selected,
					xvf_set_selected,		},
{0, XVF_OPTIONAL,   	KINT,		xvf_get_optional,
					xvf_set_optional,		},
{0, XVF_OPTSEL,	  	KINT,		xvf_get_optsel,
					xvf_set_optsel,			},
{0, XVF_LIVE,	  	KINT,		xvf_get_live,
					xvf_set_live,			},
{0, XVF_VARIABLE,	KSTRING,	xvf_get_variable,
					xvf_set_variable,		},
{0, XVF_DESCRIPTION, 	KSTRING,	xvf_get_description,
					xvf_set_description,		},
{0, XVF_TITLE,  	KSTRING,	xvf_get_title,
					xvf_set_title,			},
{0, XVF_BUTTONTITLE, 	KSTRING,	xvf_get_buttontitle,
					xvf_set_buttontitle,		},
{0, XVF_GUIDEPANETITLE, KSTRING,	xvf_get_guidepanetitle,
					xvf_set_guidepanetitle,		},
{0, XVF_LITERAL,	KSTRING,	xvf_get_literal,	
					xvf_set_literal,		},
{0, XVF_MODIFIED,	KINT,		xvf_get_modified,
					xvf_set_modified,		},
{0, XVF_WIDTH, 		KFLOAT,		xvf_get_width,
					xvf_set_width,			},
{0, XVF_HEIGHT,		KFLOAT,		xvf_get_height,
					xvf_set_height,			},
{0, XVF_X,		KFLOAT,		xvf_get_x,
					xvf_set_x,			},
{0, XVF_Y,		KFLOAT,		xvf_get_y,
					xvf_set_y,			},
{0, XVF_BUTTONWIDTH, 	KFLOAT,		xvf_get_buttonwidth,
					xvf_set_buttonwidth,		},
{0, XVF_BUTTONHEIGHT,	KFLOAT,		xvf_get_buttonheight,
					xvf_set_buttonheight,		},
{0, XVF_BUTTONX,	KFLOAT,		xvf_get_buttonx,
					xvf_set_buttonx,		},
{0, XVF_BUTTONY,	KFLOAT,		xvf_get_buttony,
					xvf_set_buttony,		},
{0, XVF_XPOS, 		KFLOAT,		xvf_get_xpos,
					xvf_set_xpos,			},
{0, XVF_YPOS, 		KFLOAT,		xvf_get_ypos,
					xvf_set_ypos,			},
{0, XVF_DELETE, 	KINT,		NULL,
					xvf_set_delete,			},
{0, XVF_PRINT_UIS, 	KSTRING,	xvf_get_print_uis,
					xvf_set_print_uis,		},
{0, XVF_PRINT_PANE,	KSTRING,	xvf_get_print_pane,
					xvf_set_print_pane,		},
{0, XVF_PRINT_SUBFORM,	KSTRING,	xvf_get_print_subform,
					xvf_set_print_subform,		},
{0, XVF_SUBFORM_FILE,	KSTRING,	xvf_get_subform_file,
					xvf_set_subform_file,		},
{0, XVF_PANE_FILE,	KSTRING,	xvf_get_pane_file,
					xvf_set_pane_file,		},
{0, XVF_UIS_LOCATION,	KSTRING,	xvf_get_uis_location,
					xvf_set_uis_location,		},
{0, XVF_CLIENTDATA,	KSTRUCT,	xvf_get_clientdata,
					xvf_set_clientdata,		},
{0, XVF_DISPLAY_SUBFORM,KINT,		NULL,
					xvf_set_display_subform,	},
{0, XVF_DISPLAY_PANE,	KINT,		NULL,
					xvf_set_display_pane,		},
{0, XVF_FILE_NAME,      KSTRING,	xvf_get_file_name,
					xvf_set_file_name,		},
{0, XVF_FILE_CHECK,     KINT,       	xvf_get_file_check,
					xvf_set_file_check,		},
{0, XVF_FILE_DEF,	KSTRING,	xvf_get_file_def,
					xvf_set_file_def,		},
{0, XVF_STRING_VAL, 	KSTRING,	xvf_get_string_val,
					xvf_set_string_val,		},
{0, XVF_STRING_DEF, 	KSTRING,	xvf_get_string_def,
					xvf_set_string_def,		},
{0, XVF_STRING_MULTILINE, KINT,		xvf_get_string_multiline,
					xvf_set_string_multiline,	},
{0, XVF_EXECTYPE,	 KINT,		xvf_get_exectype,
					xvf_set_exectype,		},
{0, XVF_ROUTINE,	KSTRING,	xvf_get_routine,
					xvf_set_routine,		},
{0, XVF_HELPPATH,	KSTRING,	xvf_get_help_path,
					xvf_set_help_path,		},
{0, XVF_TOGGLE_SIZE,    KINT,		xvf_get_toggle_size,
					xvf_set_toggle_size,		},
{0, XVF_TOGGLE_MEMBERS, KINT,	        NULL,
					xvf_set_toggle_members,		},
{0, XVF_TOGGLE_NUM,	KINT,       	xvf_get_toggle_num,
					xvf_set_toggle_num,		},
{0, XVF_TOGGLE_VAL,	KSTRING,       	xvf_get_toggle_val,
					xvf_set_toggle_val,		},
{0, XVF_TOGGLE_TYPE, 	KINT,	        xvf_get_toggle_type,
					NULL,				},
{0, XVF_LOGIC_VAL, 	KINT,	        xvf_get_logic_val,
					xvf_set_logic_val,		},
{0, XVF_LOGIC_DEF, 	KINT,	        xvf_get_logic_def,
					xvf_set_logic_def,		},
{0, XVF_LOGIC_1LABEL, 	KSTRING,	xvf_get_logic_label,
					xvf_set_logic_label,		},
{0, XVF_LOGIC_0LABEL, 	KSTRING,	xvf_get_logic_label,
					xvf_set_logic_label,		},
{0, XVF_LIST_SIZE,	KINT,     	xvf_get_list_size,
					xvf_set_list_size,		},
{0, XVF_LIST_VAL,	KINT, 		xvf_get_list_val,
					xvf_set_list_val,		},
{0, XVF_LIST_LABEL,     KSTRING,   	xvf_get_list_label,
					xvf_set_list_label,		},
{0, XVF_LIST_INDEX,     KINT,   	xvf_get_list_index,
					xvf_set_list_index,		},
{0, XVF_LIST_START,  	KINT,      	xvf_get_list_start,
					xvf_set_list_start,		},
{0, XVF_LIST_CONTENTS,  KSTRUCT,    	xvf_get_list_contents,
					xvf_set_list_contents,		},
{0, XVF_LIST_CHOICES,  KSTRUCT,    	NULL,
					xvf_set_list_choices,		},
{0, XVF_LIST_DOUBLECLICK, KINT,       	xvf_get_list_doubleclick,
					xvf_set_list_doubleclick,	},
{0, XVF_LIST_ADD,   	KSTRING,    	NULL,
					xvf_set_list_add,		},
{0, XVF_LIST_DELETE,    KSTRING,	NULL,
					xvf_set_list_delete,		},
{0, XVF_LIST_DELETEALL, KINT,	    	NULL,
					xvf_set_list_deleteall,		},
{0, XVF_CYCLE_SIZE,	KINT,     	xvf_get_list_size,
					xvf_set_list_size,		},
{0, XVF_CYCLE_VAL,	KINT, 		xvf_get_list_val,
					xvf_set_list_val,		},
{0, XVF_CYCLE_LABEL,     KSTRING,   	xvf_get_list_label,
					xvf_set_list_label,		},
{0, XVF_CYCLE_INDEX,     KINT,   	xvf_get_list_index,
					xvf_set_list_index,		},
{0, XVF_CYCLE_START,  	KINT,      	xvf_get_list_start,
					xvf_set_list_start,		},
{0, XVF_CYCLE_CONTENTS,  KSTRUCT,    	xvf_get_list_contents,
					xvf_set_list_contents,		},
{0, XVF_CYCLE_CHOICES,  KSTRUCT,    	NULL,
					xvf_set_list_choices,		},
{0, XVF_CYCLE_ADD,   	KINT, 	    	NULL,
					xvf_set_list_add,		},
{0, XVF_CYCLE_DELETE,    KINT,	    	NULL,
					xvf_set_list_delete,		},
{0, XVF_CYCLE_DELETEALL, KINT,	    	NULL,
					xvf_set_list_deleteall,		},
{0, XVF_INT_GT0_SEL, 	KINT, 	    	xvf_get_int_gt0_sel,
					xvf_set_int_gt0_sel,		},
{0, XVF_INT_GE0_SEL,  	KINT,	    	xvf_get_int_ge0_sel,
					xvf_set_int_ge0_sel,		},
{0, XVF_INT_LT0_SEL, 	KINT, 	    	xvf_get_int_lt0_sel,
					xvf_set_int_lt0_sel,		},
{0, XVF_INT_LE0_SEL,  	KINT,	    	xvf_get_int_le0_sel,
					xvf_set_int_le0_sel,		},
{0, XVF_INT_BOUNDS_SEL, KINT,	    	xvf_get_bounds_sel,
					xvf_set_bounds_sel,		},
{0, XVF_INT_NOBOUNDS_SEL, KINT,      	xvf_get_nobounds_sel,
					xvf_set_nobounds_sel,		},
{0, XVF_INT_LOWER_SEL,  KINT,      	xvf_get_bounds_sel,
					xvf_set_bounds_sel,		},
{0, XVF_INT_UPPER_SEL,  KINT,      	xvf_get_bounds_sel,
					xvf_set_bounds_sel,		},
{0, XVF_INT_UPPER,      KINT,	        xvf_get_int_upper,
					xvf_set_int_upper,		},
{0, XVF_INT_LOWER,      KINT,	        xvf_get_int_lower,
					xvf_set_int_lower,		},
{0, XVF_INT_DEF, 	KINT,           xvf_get_int_def,
					xvf_set_int_def,		},
{0, XVF_INT_VAL, 	KINT,     	xvf_get_int_val,
					xvf_set_int_val,		},
{0, XVF_MECHANISM, 	KINT,     	xvf_get_mechanism,
					xvf_set_mechanism,		},
{0, XVF_FLOAT_GT0_SEL, 	KINT, 	    	xvf_get_float_gt0_sel,
					xvf_set_float_gt0_sel,		},
{0, XVF_FLOAT_GE0_SEL, 	KINT, 	    	xvf_get_float_ge0_sel,
					xvf_set_float_ge0_sel,		},
{0, XVF_FLOAT_LT0_SEL, 	KINT, 	    	xvf_get_float_lt0_sel,
					xvf_set_float_lt0_sel,		},
{0, XVF_FLOAT_LE0_SEL, 	KINT, 	    	xvf_get_float_le0_sel,
					xvf_set_float_le0_sel,		},
{0, XVF_FLOAT_BOUNDS_SEL, KINT, 	xvf_get_bounds_sel,
					xvf_set_bounds_sel,		},
{0, XVF_FLOAT_NOBOUNDS_SEL, KINT,    	xvf_get_nobounds_sel,
					xvf_set_nobounds_sel,		},
{0, XVF_FLOAT_LOWER_SEL,  KINT,      	xvf_get_bounds_sel,
					xvf_set_bounds_sel,		},
{0, XVF_FLOAT_UPPER_SEL,  KINT,      	xvf_get_bounds_sel,
					xvf_set_bounds_sel,		},
{0, XVF_FLOAT_UPPER,    KFLOAT, 	xvf_get_float_upper,
					xvf_set_float_upper,		},
{0, XVF_FLOAT_LOWER,   	KFLOAT,   	xvf_get_float_lower,
					xvf_set_float_lower,		},
{0, XVF_FLOAT_DEF,    	KFLOAT,  	xvf_get_float_def,
					xvf_set_float_def,		},
{0, XVF_FLOAT_VAL,	KFLOAT,      	xvf_get_float_val,
					xvf_set_float_val,		},
{0, XVF_FLOAT_PREC,    	KINT,  	        xvf_get_precision,
					xvf_set_precision,		},
{0, XVF_DOUBLE_GT0_SEL, KINT,	    	xvf_get_double_gt0_sel,
					xvf_set_double_gt0_sel,		},
{0, XVF_DOUBLE_GE0_SEL, KINT, 	    	xvf_get_double_ge0_sel,
					xvf_set_double_ge0_sel,		},
{0, XVF_DOUBLE_LT0_SEL,  KINT,	    	xvf_get_double_lt0_sel,
					xvf_set_double_lt0_sel,		},
{0, XVF_DOUBLE_LE0_SEL,  KINT,	    	xvf_get_double_le0_sel,
					xvf_set_double_le0_sel,		},
{0, XVF_DOUBLE_BOUNDS_SEL, KINT,  	xvf_get_bounds_sel,
					xvf_set_bounds_sel,		},
{0, XVF_DOUBLE_NOBOUNDS_SEL, KINT,     	xvf_get_nobounds_sel,
					xvf_set_nobounds_sel,		},
{0, XVF_DOUBLE_LOWER_SEL,  KINT,      	xvf_get_bounds_sel,
					xvf_set_bounds_sel,		},
{0, XVF_DOUBLE_UPPER_SEL,  KINT,      	xvf_get_bounds_sel,
					xvf_set_bounds_sel,		},
{0, XVF_DOUBLE_UPPER,   KDOUBLE,   	xvf_get_double_upper,
					xvf_set_double_upper,		},
{0, XVF_DOUBLE_LOWER,   KDOUBLE,  	xvf_get_double_lower,
					xvf_set_double_lower,		},
{0, XVF_DOUBLE_DEF,  	KDOUBLE,     	xvf_get_double_def,
					xvf_set_double_def,		},
{0, XVF_DOUBLE_VAL,  	KDOUBLE,    	xvf_get_double_val,
					xvf_set_double_val,		},
{0, XVF_DOUBLE_PREC,   	KINT,           xvf_get_precision,
					xvf_set_precision,		},
};

/*
 * note that xvf_attribute_num has to be defined in the same file
 * as the xvf_attribute_table definition, or knumber will not work right.
 */
int xvf_attribute_num = knumber(xvf_attribute_table);
